"""Modify connection strategy workflow.

Revision ID: a2cd3f2e6d7a
Revises:
Create Date: 2024-03-21 16:05:59.043106

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = 'a2cd3f2e6d7a'
down_revision = 'd61c0f92da1e'
branch_labels = None
depends_on = None


from orchestrator.migrations.helpers import create_workflow, delete_workflow

new_workflows = [
    {
        "name": "modify_connection_strategy",
        "target": "MODIFY",
        "description": "Modify connection strategy",
        "product_type": "Router"
    }
]


def upgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        create_workflow(conn, workflow)


def downgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        delete_workflow(conn, workflow["name"])
