"""Add Import Edge Port workflows..

Revision ID: f900cbaa47d7
Revises: 3b65a9c88aba
Create Date: 2024-09-23 10:58:47.196446

"""
import sqlalchemy as sa
from alembic import op

# revision identifiers, used by Alembic.
revision = 'f900cbaa47d7'
down_revision = '3b65a9c88aba'
branch_labels = None
depends_on = None


from orchestrator.migrations.helpers import create_workflow, delete_workflow

new_workflows = [
    {
        "name": "create_imported_edge_port",
        "target": "CREATE",
        "description": "Import Edge Port",
        "product_type": "ImportedEdgePort"
    },
    {
        "name": "import_edge_port",
        "target": "MODIFY",
        "description": "Import Edge Port",
        "product_type": "ImportedEdgePort"
    }
]


def upgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        create_workflow(conn, workflow)


def downgrade() -> None:
    conn = op.get_bind()
    for workflow in new_workflows:
        delete_workflow(conn, workflow["name"])
